
\section*{Abstract}

In the modern landscape of Information and Communication Technologies, Cybersecurity is more important than ever. In recent years we have seen an exponential growth in services available to every computer, allowing every person to please every kind of need, from a basic one like e-commerce to keeping in touch with your friends on social medias. However, this led to an incumbent advancement in security measures, given the manipulation of users’ sensitive data over the Internet, a notorious place for its wide-spread presence of insecure applications and users.


The definition of the term “sensitive data” can be more complicated than it seems, that is because it does not necessarily refers to just personal records, that may be the one used during transactions with government services for example, but even information stored in our favorite apps that we use daily and seem useless can be used to harm us in many ways. For instance, many of us have used tracking features in mobiles phones, needed for simple games or even looking for directions, and may have never realized how dangerous they can be. This is why it is crucial to create and implement the right technologies to authenticate and authorize every user online, two faces of the same coin. Every application has to certify every transaction a user is requesting and before that, check that the user is allowed to carry out this operation. Errors in these 2 crucial sections during the common usage flow can have repercussions in many ways: integrity and confidentiality of other user’s data can no longer be guaranteed.


In order to solve the problems stated above, in this thesis we provide a contribution divided in two sections. The first one, a state of the art search of the available automated scanners of the most used protocols for authentication and authorization, that establishes what vulnerabilities they can test for and how. We focused on the implementation of every tool, especially its availability (closed or open source), language used, plugin or standalone app and limitations (compatible with a subset of protocols, speed, compatible platforms).


After that we searched the missing vulnerabilities that were not covered by the tools found in the first step. We used the OAuth 2.0 Security Best Current Practice draft-ietf-oauth-security-topics-13 \cite{best_current_practice} to have a complete list of the usual mistakes made during the implementation of the protocols and combined it with the Threats and Vulnerabilities in Federation Protocols and Products(OWASP Helsinki Chapter Meeting \#30) \cite{helsinki_owasp}.


With all this information we have a comprehensive description of how and where the programmers, even following the protocol guidelines, misjudge and leave out some key components used to ensure security. This happens because protocol guidelines provide extensive description on all the elements used, about how and why they were created, but some some are listed as \textit{optional}. This creates a wide variety of implementations, each having different architecture with different characteristics but also vulnerable in essential areas.


Attackers can take advantage of that, by just simply scanning network traffic while using the services provided. Fundamentals elements can be easily found and saved or manipulated during the use of web applications. This ease for attackers to find information about the services' architecture and features implementations is obviously not acceptable for security reasons.


\newpage